Attribute VB_Name = "Module1"
Option Explicit

Private Declare Function SendMessage Lib "user32" _
                         Alias "SendMessageA" ( _
                         ByVal hwnd As Long, _
                         ByVal wMsg As Long, _
                         ByVal wParam As Long, _
                         lParam As Any) As Long
                         
Private Declare Function GetWindowLong Lib "user32" _
                         Alias "GetWindowLongA" ( _
                         ByVal hwnd As Long, _
                         ByVal nIndex As Long) As Long
                         
Private Declare Function SetWindowLong Lib "user32" _
                         Alias "SetWindowLongA" ( _
                         ByVal hwnd As Long, _
                         ByVal nIndex As Long, _
                         ByVal dwNewLong As Long) As Long
                         
Private Declare Function SetWindowPos Lib "user32" ( _
                         ByVal hwnd As Long, _
                         ByVal hWndInsertAfter As Long, _
                         ByVal x As Long, _
                         ByVal y As Long, _
                         ByVal cx As Long, _
                         ByVal cy As Long, _
                         ByVal wFlags As Long) As Long
                         
Private Const GWL_STYLE = (-16) ' Fensterstil
Private Const LVM_SETCOLUMNWIDTH = &H101E ' gibt an, dass Spaltenbreite gesetzt werden
                                          ' soll
Private Const LVSCW_AUTOSIZE = (-1) ' automatisch optimale Spaltenbreite
Private Const LVSCW_AUTOSIZE_USEHEADER = (-2) ' sorgt dafr, dass alle
                                              ' Spaltenberschriften lesbar sind
Private Const LVM_FIRST = &H1000
Private Const LVM_GETHEADER = (LVM_FIRST + 31) ' gibt Handle des ListViewHeaders zurck
Private Const HDS_BUTTONS As Long = &H2 ' Headerstil "Buttons"
Private Const SWP_NOMOVE As Long = &H2 ' Fenster nicht verschieben
Private Const SWP_NOSIZE As Long = &H1 ' Fenstergre nicht ndern
Private Const SWP_NOZORDER As Long = &H4 ' Fensteranordnung (vorne, hinten) nicht ndern

Public Sub FlatListView(ByRef CListView As ListView, COwner As Form)

    Dim hHeader As Long, lStyle As Long
    
    hHeader = SendMessage(CListView.hwnd, LVM_GETHEADER, 0, 0)
    lStyle = GetWindowLong(hHeader, GWL_STYLE)
    lStyle = lStyle Xor HDS_BUTTONS
    
    If lStyle Then
    
        SetWindowLong hHeader, GWL_STYLE, lStyle
        
        SetWindowPos CListView.hwnd, COwner.hwnd, 0, 0, 0, 0, SWP_NOMOVE Or SWP_NOZORDER _
            Or SWP_NOSIZE
    End If
    
End Sub

Public Sub OptimalHeaderWidth(ByRef CListView As ListView)

    Dim i As Integer
    
    ' //Alle Spaltenkpfe durchgehen
    For i = 0 To CListView.ColumnHeaders.Count - 1
        SendMessage CListView.hwnd, LVM_SETCOLUMNWIDTH, i, -3
    Next i
    
End Sub


